#include "mylib.h"
#include "test.h"

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wp, LPARAM lp);
HINSTANCE ghInstance;

int WINAPI WinMain
(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR pCmdLine, int nCmdShow)
{
HWND hWnd;
MSG msg;
BOOL ret;
NotUseParameters(2, hPrevInstance, pCmdLine);
ghInstance = hInstance;

hWnd = Create(hInstance, WndProc, "MonitorDown", "MonitorDown");
if (hWnd==NULL) return 1;
ShowWindow(hWnd, nCmdShow);
UpdateWindow(hWnd);

while (1) {
	ret = GetMessage(&msg, NULL, 0, 0);
	if (ret==0||ret==-1) break;
	else {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		}
	}

return 0;
}

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
static BOOL set = FALSE;
static HWND hButton[2];

switch (msg) {
	case WM_CREATE:
		SetWndHandle(hWnd);
		hButton[0] = CreateWindow(
			"BUTTON",
			"Jn",
			WS_CHILD|WS_VISIBLE,
			9,
			87,
			81,
			12,
			hWnd,
			(HMENU)ID_START,
			ghInstance,
			NULL
			);
		hButton[1] = CreateWindow(
			"BUTTON",
			"~",
			WS_CHILD|WS_VISIBLE,
			102,
			87,
			81,
			12,
			hWnd,
			(HMENU)ID_END,
			ghInstance,
			NULL
			);
		break;

	case WM_SETFOCUS:
		SetFocus(hButton[0]);
		break;
	case WM_ACTIVATEAPP:
		if (wp==FALSE)
			SetWndHandle(hWnd);
		break;

	case WM_COMMAND:
		switch (LOWORD(wp)) {
			case ID_START:
				if (set) break;
				if (!SetHook()) {
					MessageBox(hWnd, "SetHooks", "Error", MB_OK|MB_ICONEXCLAMATION);
					break;
					}
				if (!SetTimer(hWnd, ID_MYTIMER, 5000, NULL)) {
					MessageBox(hWnd, "SetTimers", "Error", MB_OK|MB_ICONEXCLAMATION);
					break;
					}
				set = TRUE;
BreakPoint("start");
				break;

			case ID_END:
				if (!set) break;
				if (!ResetHook()) {
					MessageBox(hWnd, "ResetHooks", "Error", MB_OK|MB_ICONEXCLAMATION);
					}
				if (!KillTimer(hWnd, ID_MYTIMER)) {
					MessageBox(hWnd, "KillTimers", "Error", MB_OK|MB_ICONEXCLAMATION);
					break;
					}
				set = FALSE;
BreakPoint("end");
				break;
			}
		break;

	case WM_KEYHOOK:
		if (!set) break;
		if (!ResetHook()) {
			MessageBox(hWnd, "ResetHooks", "Error", MB_OK|MB_ICONEXCLAMATION);
			break;
			}
		if (!KillTimer(hWnd, ID_MYTIMER)) {
			MessageBox(hWnd, "KillTimers", "Error", MB_OK|MB_ICONEXCLAMATION);
			break;
			}
		set = FALSE;
BreakPoint("end");
		break;

	case WM_TIMER:
		PostMessage(HWND_BROADCAST, WM_SYSCOMMAND, SC_MONITORPOWER, 2);
		break;

	case WM_CLOSE:
		if (set) {
			MessageBox(hWnd, "tbNĂ܂B", "Warning", MB_OK|MB_ICONEXCLAMATION);
			return 0;
			}
		else {
			DestroyWindow(hButton[0]);
			DestroyWindow(hButton[1]);
			DestroyWindow(hWnd);
			}
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	}
return DefWindowProc(hWnd, msg, wp, lp);
}